
/*
 * $Id: Progress.cc,v 1.6 1999/09/07 17:46:23 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Clock.h"
#include "OLog.h"
#include "ILog.h"
#include "Progress.h"

Progress TheProgress;


Progress::Progress() {
	theXactCnt = theErrCnt = 0;
}

Time Progress::time() const {
	return theTimestamp < 0 ? TheClock.time() : theTimestamp;
}

void Progress::store(OLog &ol) const {
	ol << TheClock.time() << theXactCnt << theErrCnt;
}

void Progress::load(ILog &il) {
	il >> theTimestamp >> theXactCnt >> theErrCnt;
}

ostream &Progress::print(ostream &os) const {
	os << theXactCnt << ':';
	if (theTimestamp < 0)
		os << (TheClock - Clock::TheStartTime);
	else
		os << (theTimestamp - Clock::TheStartTime);
	return os << ':' << theErrCnt;
}
