
/*
 * $Id: CltConnMgr.h,v 1.8 1999/09/22 21:59:50 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CLIENT_CONNECTION_MANAGER_H
#define PG_CLIENT_CONNECTION_MANAGER_H

#include "NetAddr.h"
#include "Queue.h"
#include "ConnMgr.h"

class PortMgr;

class CltConnMgr: public ConnMgr {
	public:
		CltConnMgr();
		virtual ~CltConnMgr();

		void configure(const NetAddr &anAddr, const SockOpt &anOpt, int idleLvlMax, RndDistr *aPconnUseLmt);
		void portMgr(PortMgr *aPortMgr);

		virtual Connection *get();

		virtual void noteReadReady(int fd);

	protected:
		Connection *open();
		virtual void putIdle(Connection *conn);
		void closeIdle(Connection *conn, ConnCloseStat::CloseKind ck);

	protected:
		Queue<Connection> theIdleConns;
		PortMgr *thePortMgr;
		int theIdleLvlLmt;
};

#endif
