
/*
 * $Id: SrvXact.h,v 1.9 1999/09/26 21:51:25 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef SRV_XACTION_H
#define SRV_XACTION_H

#include "Xaction.h"
#include "AlarmClock.h"
#include "ObjTimes.h"
#include "httpHdrs.h"

class Server;
class WrBuf;
class ContentCfg;
class ContBuildIter;

class SrvXact: public Xaction, public AlarmUser {
	public:
		SrvXact() { reset(); }

		void reset();

		void exec(Server *anOwner, Connection *aConn, Time delay);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);
		virtual void wakeUp(const Alarm &a);

	protected:
		void makeRep(WrBuf &buf);
		void makeRep200(ostream &os);
		void makeRep304(ostream &os);
		void putStdFields(ostream &os) const;

		Size calcRepSize() const;
		bool calcCachability() const;

		void doStart();
		void noteDataReady();
		void gotHeader();
		void finish(int errNo);

	protected:
		Server *theOwner;
		ContentCfg *theContentCfg;
		ContBuildIter *theContBuildIter;
		ReqHdr theReqHdr;

		ObjTimes theTimes;    // mod, lmt, and such
		Size theRepHdrSize;

		Size theProducedSize;
};

#endif

