
/*
 * $Id: PglPp.h,v 1.4 1999/09/07 17:48:06 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef POLYGRAPH_PGL_PP_H
#define POLYGRAPH_PGL_PP_H

#include "Array.h"
#include "Lexer.h"

class String;
class istream;
class GLexer;

// PGL preprocessor

class PglPp: public Lexer {
	public:
		PglPp(const String &fname);
		virtual ~PglPp();

	protected:
		virtual LexToken scan();
		void advance();

		GLexer *lexer() { return theLexers[theDepth-1]; }
		const GLexer *lexer() const { return theLexers[theDepth-1]; }

		bool filtered();
		void ignoreLineCmnt();
		void ignoreBlockCmnt();
		void ppdInclude();
		void ppDirective();
		void system();

		void open(const String &fname);
		void popen(const String &cmd);
		void open(istream &is, const String &fname);
		void close();

		void printLexers(ostream &os) const;

	public:
		static Array<String*> TheDirs;
	
	protected:
		GLexer *theLexers[256]; // replace with Array
		int theDepth;           // nesting depth
};

#endif
