
/*
 * $Id: popModels.cc,v 1.2 1999/09/17 23:54:54 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include <math.h>
#include <iostream.h>

#include "Rnd.h"
#include "popModels.h"


/* UnifPopModel */

int UnifPopModel::select(RndGen &rng, int lastOid) {
	return 1 + rng(0, lastOid);
}

ostream &UnifPopModel::print(ostream &os) const {
	return os << "pmUnif()";
}


/* ZipfPopModel */

ZipfPopModel::ZipfPopModel(double aSkew): theSkew(aSkew) {
}

int ZipfPopModel::select(RndGen &rng, int lastOid) {
	return 1 + lastOid - (int)pow(lastOid+1, pow(rng(),theSkew));
}

ostream &ZipfPopModel::print(ostream &os) const {
	return os << "pmZipf(" << theSkew << ')';
}
