
/*
 * $Id: rndDistrStat.cc,v 1.1 1999/09/28 05:14:01 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include <limits.h>

#include "Rnd.h"
#include "AggrStat.h"
#include "gadgets.h"

AggrStat RndDistrStat(RndDistr *d, double scale, int sampleSize) {
	Assert(d);
	AggrStat s;
	while (sampleSize-- > 0) {
		const double t = scale * d->trial();
		s.record((int)MiniMax((double)INT_MIN, t, (double)INT_MAX));
	}
	return s;
}
