
/*
 * $Id: BitMask.cc,v 1.3 1999/09/26 23:36:24 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xstd.h"

#include "BitMask.h"

#include <string.h>

void BitMask::resize(int aCapacity) {
	if (aCapacity == theCapacity)
		return;

	delete[] theBins;
	if (aCapacity > 0) {
		theBins = new Bin[BinCount(aCapacity)];
		theCapacity = aCapacity;
		clear();
	} else {
		theBins = 0;
		theCapacity = 0;
		theCount = 0;
	}
}

void BitMask::clear() {
	if (theBins) {
		memset(theBins, 0, BinCount(theCapacity) * sizeof(*theBins));
		theCount = 0;
	}
}

